;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: DAC9_1.inc
;;   Version: 1.2, Updated on 2003/08/28 at 17:07:49
;;  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
;;
;;  DESCRIPTION:  Assembler declarations for the DAC9 user module interface
;;                for the 22/24/25/26/27xxx PSoC family of devices.
;;
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"

;--------------------------------------------------
; Constants for DAC9_1 API's
;--------------------------------------------------
DAC9_1_OFF:              equ 00h
DAC9_1_LOWPOWER:         equ 01h
DAC9_1_MEDPOWER:         equ 02h
DAC9_1_HIGHPOWER:        equ 03h
DAC9_1_FULLPOWER:        equ 03h

DAC9_1_LSB_CR0:          equ 90h
DAC9_1_LSB_CR1:          equ 91h
DAC9_1_LSB_CR2:          equ 92h
DAC9_1_LSB_CR3:          equ 93h
DAC9_1_MSB_CR0:          equ 94h
DAC9_1_MSB_CR1:          equ 95h
DAC9_1_MSB_CR2:          equ 96h
DAC9_1_MSB_CR3:          equ 97h

DAC9_1_OffsetBinary:     equ 04h
DAC9_1_TwosComplement:   equ 02h
DAC9_1_SignAndMagnitude: equ 01h
DAC9_1_RawRegister:      equ 00h

DAC9_1_DATAFORMAT:       equ 7h
DAC9_1_OFFSETBINARY:     equ DAC9_1_DATAFORMAT & DAC9_1_OffsetBinary
DAC9_1_TWOSCOMPLEMENT:   equ DAC9_1_DATAFORMAT & DAC9_1_TwosComplement
DAC9_1_SIGNANDMAGNITUDE: equ DAC9_1_DATAFORMAT & DAC9_1_SignAndMagnitude

DAC9_1_PHASE_Normal:     equ 0
DAC9_1_PHASE_Swapped:    equ 1

DAC9_1_PHASE_SWAP:       equ DAC9_1_PHASE_Normal

IF DAC9_1_PHASE_SWAP
    DAC9_1_CR0_HIBITS:   equ C0h
ELSE
    DAC9_1_CR0_HIBITS:   equ 80h
ENDIF

;--------------------------------------------------
; Register Address Constants for DAC9_1
;--------------------------------------------------
DAC9_1_LSB_CR0: equ 90h                          ; LSB SC Block Control Register 0
DAC9_1_LSB_CR1: equ 91h                          ; LSB SC Block Control Register 1
DAC9_1_LSB_CR2: equ 92h                          ; LSB SC Block Control Register 2
DAC9_1_LSB_CR3: equ 93h                          ; LSB SC Block Control Register 3

DAC9_1_MSB_CR0: equ 94h                          ; MSB SC Block Control Register 0
DAC9_1_MSB_CR1: equ 95h                          ; MSB SC Block Control Register 1
DAC9_1_MSB_CR2: equ 96h                          ; MSB SC Block Control Register 2
DAC9_1_MSB_CR3: equ 97h                          ; MSB SC Block Control Register 3

; end of file DAC9_1.inc
