	.module main.c
	.area data(ram, con, rel)
_MAXC::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e MAXC _MAXC I
_TEMPC::
	.blkb 2
	.area idata
	.word 500
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e TEMPC _TEMPC I
_degC::
	.blkb 4
	.area idata
	.byte 53,48,48,0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e degC _degC A[4:4]c
_degF::
	.blkb 4
	.area idata
	.byte 57,51,50,0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e degF _degF A[4:4]c
_TEMPF::
	.blkb 2
	.area idata
	.word 932
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e TEMPF _TEMPF I
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;      KeyBuffer -> X+46
;      InputADC2 -> X+44
;    CycleBuffer -> X+42
;              z -> X+40
;              w -> X+38
;          count -> X+36
;         buffer -> X+34
;   temperature2 -> X+30
;    lcd_Reading -> X+22
;    lcd_Setting -> X+14
;              x -> X+12
;        KeyRead -> X+10
;           base -> X+8
;           stop -> X+6
;       InputADC -> X+4
;    temperature -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,50
	.dbline 19
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include "stdlib.h"
; 
; 
; int MAXC=0;
; int TEMPC=500;
; char degC[]="500";
; char degF[]="932";
; int TEMPF=932;
; 
; 
; 
; void main()
; {
	.dbline 23
; 	int w,z;
; 	int KeyRead,KeyBuffer;
; 	int x,buffer;
; 	float temperature=0;
	mov [X+0],0
	mov [X+1],0
	mov [X+2],0
	mov [X+3],0
	.dbline 24
; 	float temperature2=0;
	mov [X+30],0
	mov [X+31],0
	mov [X+32],0
	mov [X+33],0
	.dbline 25
; 	int count=0;
	mov [X+37],0
	mov [X+36],0
	.dbline 26
; 	int stop=1;
	mov [X+7],1
	mov [X+6],0
	.dbline 28
; 	int CycleBuffer;
; 	int base=1;
	mov [X+9],1
	mov [X+8],0
	.dbline 35
; 	int InputADC;
; 	int InputADC2;
; 	char lcd_Reading[8];
; 	char lcd_Setting[8];
; 	
; 	
;    PGA_1_SetGain(PGA_1_G1_00);  
	push X
	mov A,-8
	xcall _PGA_1_SetGain
	.dbline 36
;    PGA_1_Start(PGA_1_LOWPOWER);  
	mov A,1
	xcall _PGA_1_Start
	.dbline 37
; 	DAC9_1_Start(DAC9_1_FULLPOWER);
	mov A,3
	xcall _DAC9_1_Start
	.dbline 39
; 	
;    LCD_1_Start();                  // Initialize LCD  
	xcall _LCD_1_Start
	pop X
	.dbline 40
;     M8C_EnableGInt;                       // Enable Global Interrupts 
		or  F, 01h

L2:
	.dbline 43
; 
; AboveTop:
; 	DAC9_1_WriteBlind(0); //set output to 0V
	push X
	mov A,0
	mov X,A
	xcall _DAC9_1_WriteBlind
	.dbline 44
;    ADCINC12_1_Start(ADCINC12_1_LOWPOWER);   // Apply power to the SC Block  
	mov A,1
	xcall _ADCINC12_1_Start
	.dbline 45
;    ADCINC12_1_GetSamples(0);               // Have ADC run continuously 
	mov A,0
	xcall _ADCINC12_1_GetSamples
	.dbline 46
; 				LCD_1_Control(LCD_1_DISP_CLEAR_HOME);
	mov A,1
	xcall _LCD_1_Control
	.dbline 47
; 				LCD_1_Position(0,0);            			 
	mov A,0
	mov X,A
	xcall _LCD_1_Position
	.dbline 48
;    				LCD_1_PrCString("MAX Limit");
	mov A,>L3
	push A
	mov A,<L3
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	.dbline 50
;    				
;    	LCD_1_Position(0,10); 
	mov X,10
	mov A,0
	xcall _LCD_1_Position
	pop X
	.dbline 51
;    				if (base==0)
	cmp [X+8],0
	jnz L4
	cmp [X+9],0
	jnz L4
X11:
	.dbline 52
;    					{
	.dbline 53
;    						MAXC=TEMPF;
	mov [_MAXC+1],[_TEMPF+1]
	mov [_MAXC],[_TEMPF]
	.dbline 54
;    						LCD_1_PrString(degF);
	push X
	mov A,>_degF
	push A
	mov A,<_degF
	mov X,A
	pop A
	xcall _LCD_1_PrString
	.dbline 55
;    						LCD_1_Position(0,14);
	mov X,14
	mov A,0
	xcall _LCD_1_Position
	.dbline 56
;    						LCD_1_PrCString("F");
	mov A,>L6
	push A
	mov A,<L6
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 58
;    						 
;    					}else 
	xjmp L5
L4:
	.dbline 59
;    						{
	.dbline 60
;    							MAXC=TEMPC;
	mov [_MAXC+1],[_TEMPC+1]
	mov [_MAXC],[_TEMPC]
	.dbline 61
;    							LCD_1_PrString(degC);
	push X
	mov A,>_degC
	push A
	mov A,<_degC
	mov X,A
	pop A
	xcall _LCD_1_PrString
	.dbline 62
;    							LCD_1_Position(0,14);
	mov X,14
	mov A,0
	xcall _LCD_1_Position
	.dbline 63
;    							LCD_1_PrCString("C");
	mov A,>L7
	push A
	mov A,<L7
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 65
;    							
;    						}
L5:
	.dbline 66
L8:
	.dbline 66
;    for(;;){ 
L12:
	.dbline 69
; 		Top:
; 
; 		KeyRead=PRT1DR;				//read for keypress
	mov A,REG[4]
	mov [X+11],A
	mov [X+10],0
L13:
	.dbline 71
L14:
	.dbline 71
; 		
;       while(ADCINC12_1_fIsDataAvailable() == 0);   // Loop until value ready  
	push X
	xcall _ADCINC12_1_fIsDataAvailable
	pop X
	cmp A,0
	jz L13
	.dbline 72
;       ADCINC12_1_ClearFlag();                      // Clear ADC flag  
	push X
	xcall _ADCINC12_1_ClearFlag
	.dbline 74
; 
;       x=ADCINC12_1_iGetData();                 // Get ADC result 
	xcall _ADCINC12_1_iGetData
	mov [__r0],X
	pop X
	mov [X+13],A
	mov A,[__r0]
	mov [X+12],A
	.dbline 77
; 
; 
; 		if (InputADC>=temperature)		// Set up autostop and initial condition
	mov A,[X+5]
	mov [__r3],A
	mov A,[X+4]
	mov [__r2],A
	tst [__r2],-128
	jz X12
	mov [__r1],-1
	mov [__r0],-1
	jmp X13
X12:
	mov [__r1],0
	mov [__r0],0
X13:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,-1
	jz L16
	.dbline 78
;     	{
	.dbline 80
;     		
;     				DAC9_1_WriteBlind(0); //output 0V
	push X
	mov A,0
	mov X,A
	xcall _DAC9_1_WriteBlind
	pop X
	.dbline 82
;     		
;     	}
L16:
	.dbline 84
;     	
;     	if (stop==0)					// loop for auto restart in start condition
	cmp [X+6],0
	jnz L18
	cmp [X+7],0
	jnz L18
X15:
	.dbline 85
;     	{
	.dbline 87
;     			
;     			if (CycleBuffer<temperature)
	mov A,[X+43]
	mov [__r3],A
	mov A,[X+42]
	mov [__r2],A
	tst [__r2],-128
	jz X16
	mov [__r1],-1
	mov [__r0],-1
	jmp X17
X16:
	mov [__r1],0
	mov [__r0],0
X17:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,0
	jz L20
	cmp A,1
	jz L20
	.dbline 88
;     			{
	.dbline 89
;     				DAC9_1_WriteBlind(510); //output 5V
	push X
	mov X,1
	mov A,-2
	xcall _DAC9_1_WriteBlind
	pop X
	.dbline 90
;     			}
L20:
	.dbline 91
;     	}
L18:
	.dbline 94
;     	
;     	
; 		if (x==buffer) // check for valid ADC reading
	mov A,[X+12]
	cmp A,[X+34]
	jnz L22
	mov A,[X+13]
	cmp A,[X+35]
	jnz L22
X19:
	.dbline 95
; 			{
	.dbline 98
; 				
; 				
; 				InputADC=(x*0.5208)-12;// correction for probe resistance.
	mov A,[X+13]
	mov [__r3],A
	mov A,[X+12]
	mov [__r2],A
	tst [__r2],-128
	jz X20
	mov [__r1],-1
	mov [__r0],-1
	jmp X21
X20:
	mov [__r1],0
	mov [__r0],0
X21:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,63
	push A
	mov A,5
	push A
	mov A,83
	push A
	mov A,38
	push A
	xcall __fpmul
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,65
	push A
	mov A,64
	push A
	mov A,0
	push A
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpsub
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	add SP,-4
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fp2long
	pop A
	mov [X+5],A
	pop A
	mov [X+4],A
	add SP,-2
	.dbline 99
; 				if (base==0)
	cmp [X+8],0
	jnz L24
	cmp [X+9],0
	jnz L24
X22:
	.dbline 100
; 					{
	.dbline 101
; 						InputADC=(9.0/5.0*InputADC)+32;
	mov A,[X+5]
	mov [__r3],A
	mov A,[X+4]
	mov [__r2],A
	tst [__r2],-128
	jz X23
	mov [__r1],-1
	mov [__r0],-1
	jmp X24
X23:
	mov [__r1],0
	mov [__r0],0
X24:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,63
	push A
	mov A,-26
	push A
	mov A,102
	push A
	push A
	xcall __fpmul
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,66
	push A
	mov A,0
	push A
	push A
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpadd
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	add SP,-4
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fp2long
	pop A
	mov [X+5],A
	pop A
	mov [X+4],A
	add SP,-2
	.dbline 102
; 				}
L24:
	.dbline 105
; 				
; 				
; 			if (InputADC <= 99)    // set up display to increment 10's and 100's to left
	mov A,[X+4]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+5]
	sub A,99
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jz X25
	jnc L26
X25:
	.dbline 106
; 				{
	.dbline 107
; 					lcd_Reading[0] = ' ';
	mov [X+22],32
	.dbline 108
; 					w=1;
	mov [X+39],1
	mov [X+38],0
	.dbline 109
; 					if (InputADC <=9)
	mov A,[X+4]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+5]
	sub A,9
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jz X26
	jnc L27
X26:
	.dbline 110
; 					{
	.dbline 111
; 						lcd_Reading[1]=' ';
	mov [X+23],32
	.dbline 112
; 						w=2;
	mov [X+39],2
	mov [X+38],0
	.dbline 113
; 					}
	.dbline 114
	xjmp L27
L26:
	.dbline 114
; 				}else w=0; 
	mov [X+39],0
	mov [X+38],0
L27:
	.dbline 116
; 			
; 			InputADC2 = abs(InputADC); // absolute value
	mov A,[X+4]
	push A
	mov A,[X+5]
	push A
	xcall _abs
	mov A,[__r1]
	mov [X+45],A
	mov A,[__r0]
	mov [X+44],A
	.dbline 120
; 			
; 
; // convert int into a base 10 null terminated ASCII string 
; 			itoa(&lcd_Reading[w], (unsigned int)InputADC2, 10); 
	mov A,0
	push A
	mov A,10
	push A
	mov A,[X+44]
	push A
	mov A,[X+45]
	push A
	mov [__r1],X
	add [__r1],22
	mov A,[X+39]
	add A,[__r1]
	mov [__r1],A
	mov A,[X+38]
	adc A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _itoa
	add SP,-8
	.dbline 122
; 
; 			if (temperature <= 99)   // set up input to read correctly
	mov A,66
	push A
	mov A,-58
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,1
	jz L31
	.dbline 123
; 				{
	.dbline 124
; 					lcd_Setting[0] = ' ';
	mov [X+14],32
	.dbline 125
; 					z=1;
	mov [X+41],1
	mov [X+40],0
	.dbline 126
; 					if (temperature <=9)
	mov A,65
	push A
	mov A,16
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,1
	jz L32
	.dbline 127
; 					{
	.dbline 128
; 						lcd_Setting[1]=' ';
	mov [X+15],32
	.dbline 129
; 						z=2;
	mov [X+41],2
	mov [X+40],0
	.dbline 130
; 					}
	.dbline 131
	xjmp L32
L31:
	.dbline 131
; 				}else z=0;
	mov [X+41],0
	mov [X+40],0
L32:
	.dbline 133
; 				
; 			temperature2 = abs(temperature); 
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fp2long
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	push A
	mov A,[__r1]
	push A
	xcall _abs
	add SP,-2
	mov A,[__r1]
	mov [X+33],A
	mov A,[__r0]
	mov [X+32],A
	tst [X+32],-128
	jz X29
	mov [X+31],-1
	mov [X+30],-1
	jmp X30
X29:
	mov [X+31],0
	mov [X+30],0
X30:
	mov A,[X+30]
	push A
	mov A,[X+31]
	push A
	mov A,[X+32]
	push A
	mov A,[X+33]
	push A
	xcall __long2fp
	pop A
	mov [X+33],A
	pop A
	mov [X+32],A
	pop A
	mov [X+31],A
	pop A
	mov [X+30],A
	.dbline 136
; 
; // converts int into a base 10 null terminated ASCII string 
; 				itoa(&lcd_Setting[z], (unsigned int)temperature2, 10); 
	mov A,0
	push A
	mov A,10
	push A
	mov A,71
	push A
	mov A,0
	push A
	push A
	push A
	mov A,[X+30]
	push A
	mov A,[X+31]
	push A
	mov A,[X+32]
	push A
	mov A,[X+33]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,-1
	jz L37
	mov A,71
	push A
	mov A,0
	push A
	push A
	push A
	mov A,[X+30]
	push A
	mov A,[X+31]
	push A
	mov A,[X+32]
	push A
	mov A,[X+33]
	push A
	xcall __fpsub
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	add SP,-4
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fp2long
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-2
	mov A,[__r1]
	mov [X+49],A
	mov A,[__r0]
	adc A,-128
	mov [X+48],A
	xjmp L38
L37:
	mov A,[X+30]
	push A
	mov A,[X+31]
	push A
	mov A,[X+32]
	push A
	mov A,[X+33]
	push A
	xcall __fp2long
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-2
	mov A,[__r1]
	mov [X+49],A
	mov A,[__r0]
	mov [X+48],A
L38:
	mov A,[X+48]
	push A
	mov A,[X+49]
	push A
	mov [__r1],X
	add [__r1],14
	mov A,[X+41]
	add A,[__r1]
	mov [__r1],A
	mov A,[X+40]
	adc A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _itoa
	add SP,-6
	.dbline 139
; 				
; 				
; 			CycleBuffer=InputADC+2; 			//Set Restart lower limit
	mov A,[X+5]
	add A,2
	mov [X+43],A
	mov A,[X+4]
	adc A,0
	mov [X+42],A
	.dbline 140
; 			LCD_1_Position(1,0);              
	push X
	mov X,0
	mov A,1
	xcall _LCD_1_Position
	pop X
	.dbline 141
;   				LCD_1_PrString(lcd_Reading);    // continuous temperature display
	mov [__r1],X
	add [__r1],22
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _LCD_1_PrString
	.dbline 142
;   				LCD_1_Position(1,5);
	mov X,5
	mov A,1
	xcall _LCD_1_Position
	.dbline 143
;   				LCD_1_PrCString("SET->");
	mov A,>L39
	push A
	mov A,<L39
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	.dbline 144
;   				LCD_1_Position(1,10);
	mov X,10
	mov A,1
	xcall _LCD_1_Position
	pop X
	.dbline 145
;   				LCD_1_PrString(lcd_Setting);
	mov [__r1],X
	add [__r1],14
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _LCD_1_PrString
	pop X
	.dbline 148
; 
;    			// set key repeat function for up down keys only
;   			if (KeyRead!=0x00) //0x03 when programmer attached
	cmp [X+10],0
	jnz X32
	cmp [X+11],0
	jz L40
X32:
	.dbline 149
;   				{
	.dbline 150
;   					count++;
	inc [X+37]
	adc [X+36],0
	.dbline 151
;   					if (count>15)
	mov A,[X+36]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+37]
	sub A,15
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L41
	mov A,[__rX]
	jz L41
X33:
	.dbline 152
;   						if (KeyRead==0x80||KeyRead==0x40)
	cmp [X+10],0
	jnz X34
	cmp [X+11],-128
	jz L46
X34:
	cmp [X+10],0
	jnz L41
	cmp [X+11],64
	jnz L41
X35:
L46:
	.dbline 153
;   							goto HERE;
	xjmp L47
X0:
	.dbline 154
L40:
	.dbline 154
;   				}else count=0;	
	mov [X+37],0
	mov [X+36],0
L41:
	.dbline 156
;   				
;   			if (KeyBuffer==KeyRead) // duplicate key ignore
	mov A,[X+46]
	cmp A,[X+10]
	jnz L48
	mov A,[X+47]
	cmp A,[X+11]
	jnz L48
X36:
	.dbline 157
;   			goto Top;
	xjmp L12
L48:
L47:
	.dbline 161
;   			   			
;   				HERE:	
;   		//Programmer will add 0X03 to all cases when attached
;   				switch (KeyRead){
	cmp [X+10],0
	jnz X37
	cmp [X+11],16
	jz L72
X37:
	mov A,[X+10]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+11]
	sub A,16
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jz X38
	jnc L83
X38:
L82:
	cmp [X+10],0
	jnz X39
	cmp [X+11],4
	jz L76
X39:
	mov A,[X+10]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+11]
	sub A,4
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L50
X40:
L84:
	cmp [X+10],0
	jnz X41
	cmp [X+11],8
	jz L74
X41:
	xjmp L50
L83:
	cmp [X+10],0
	jnz X42
	cmp [X+11],64
	jz L61
X42:
	mov A,[X+10]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+11]
	sub A,64
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jz X43
	jnc L86
X43:
L85:
	cmp [X+10],0
	jnz X44
	cmp [X+11],32
	jz L70
X44:
	xjmp L50
L86:
	cmp [X+10],0
	jnz X45
	cmp [X+11],-128
	jz L52
X45:
	xjmp L50
X1:
	.dbline 161
L52:
	.dbline 163
;   					case (0x80): // increment temperature
;   						if(count>15)
	mov A,[X+36]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+37]
	sub A,15
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L53
	mov A,[__rX]
	jz L53
X46:
	.dbline 164
;   							{temperature=temperature+10;
	.dbline 164
	mov A,65
	push A
	mov A,32
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpadd
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 165
;   								count=0;
	mov [X+37],0
	mov [X+36],0
	.dbline 166
;   								if (temperature >=MAXC)
	mov [__r3],[_MAXC+1]
	mov [__r2],[_MAXC]
	tst [__r2],-128
	jz X47
	mov [__r1],-1
	mov [__r0],-1
	jmp X48
X47:
	mov [__r1],0
	mov [__r0],0
X48:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,-1
	jz L12
	.dbline 167
;   									{goto HIGHlimit;
	.dbline 167
	xjmp L57
X2:
	.dbline 169
;   									}
;   								goto Top;
L53:
	.dbline 171
;   							}
;   						KeyBuffer=KeyRead;
	mov A,[X+11]
	mov [X+47],A
	mov A,[X+10]
	mov [X+46],A
	.dbline 173
;   					
;   						if (temperature >=MAXC)
	mov [__r3],[_MAXC+1]
	mov [__r2],[_MAXC]
	tst [__r2],-128
	jz X50
	mov [__r1],-1
	mov [__r0],-1
	jmp X51
X50:
	mov [__r1],0
	mov [__r0],0
X51:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,-1
	jz L60
	.dbline 174
;   								{goto HIGHlimit;
	.dbline 174
	xjmp L57
X3:
	.dbline 176
;   								}
;   						goto TempUp;
	.dbline 177
;   					break;
L61:
	.dbline 179
;   					case (0x40):  // decrement temperature
;   						if(count>15)
	mov A,[X+36]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[X+37]
	sub A,15
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L62
	mov A,[__rX]
	jz L62
X53:
	.dbline 180
;   							{temperature=temperature-10;
	.dbline 180
	mov A,65
	push A
	mov A,32
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpsub
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 181
;   								count=0;
	mov [X+37],0
	mov [X+36],0
	.dbline 182
;   								if (temperature <=0)
	mov A,0
	push A
	push A
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,1
	jz L12
	.dbline 183
;   									{goto LOWlimit;
	.dbline 183
	xjmp L66
X4:
	.dbline 185
;   									}
;   								goto Top;
L62:
	.dbline 187
;   							}
;   							KeyBuffer=KeyRead;
	mov A,[X+11]
	mov [X+47],A
	mov A,[X+10]
	mov [X+46],A
	.dbline 189
;   						
;   							if (temperature <=0)
	mov A,0
	push A
	push A
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,1
	jz L69
	.dbline 190
;   								{goto LOWlimit;
	.dbline 190
	xjmp L66
X5:
	.dbline 192
;   								}
;   						goto TempDown;
	.dbline 193
;   					break;
L70:
	.dbline 195
;   					case (0x20): // clear
;   						KeyBuffer=KeyRead;
	mov A,[X+11]
	mov [X+47],A
	mov A,[X+10]
	mov [X+46],A
	.dbline 196
;   						goto Clear;
	xjmp L71
X6:
	.dbline 197
;   					break;
L72:
	.dbline 199
;   					case (0X10): //start
;   						KeyBuffer=KeyRead;
	mov A,[X+11]
	mov [X+47],A
	mov A,[X+10]
	mov [X+46],A
	.dbline 200
;   						goto Start;
	xjmp L73
X7:
	.dbline 201
;   					break;
L74:
	.dbline 203
;   					case (0x08): //stop
;   						KeyBuffer=KeyRead;
	mov A,[X+11]
	mov [X+47],A
	mov A,[X+10]
	mov [X+46],A
	.dbline 204
;   						goto Stop;
	xjmp L75
X8:
	.dbline 205
;   					break;
L76:
	.dbline 207
;   					case (0x04): //base change
;   						 KeyBuffer=KeyRead;
	mov A,[X+11]
	mov [X+47],A
	mov A,[X+10]
	mov [X+46],A
	.dbline 208
;   						 if (base==1)
	cmp [X+8],0
	jnz L77
	cmp [X+9],1
	jnz L77
X56:
	.dbline 209
;   						 {	//Change to F
	.dbline 210
;   						 	base=0;
	mov [X+9],0
	mov [X+8],0
	.dbline 211
;   							goto Base;
	xjmp L79
L77:
	.dbline 213
;   						 }
;   						 if (base==0)
	cmp [X+8],0
	jnz L79
	cmp [X+9],0
	jnz L79
X57:
	.dbline 214
;   						 {	//Change to C
	.dbline 215
;   						 	base=1;
	mov [X+9],1
	mov [X+8],0
	.dbline 216
;   						 }
	.dbline 218
;    						 
;   						goto Base;
	xjmp L79
X9:
	.dbline 219
;   					break;
L50:
	.dbline 221
;   					default:
;   						KeyBuffer=KeyRead;
	mov A,[X+11]
	mov [X+47],A
	mov A,[X+10]
	mov [X+46],A
	.dbline 222
;   					break;
L51:
	.dbline 226
;   					}        		
; 								
; 
;   			}
L22:
	.dbline 228
; 
;   		buffer=x; // ADC validation buffer
	mov A,[X+13]
	mov [X+35],A
	mov A,[X+12]
	mov [X+34],A
	.dbline 230
; 			
;     goto Top;
	xjmp L12
L60:
	.dbline 232
;    TempUp:
;    	temperature++; // increment setting
	mov A,63
	push A
	mov A,-128
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpadd
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 233
;    goto Top;
	xjmp L12
L69:
	.dbline 235
;    TempDown:
;    	temperature--; // decrement setting
	mov A,63
	push A
	mov A,-128
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpsub
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 236
;     goto Top;
	xjmp L12
L71:
	.dbline 238
;   Clear:
;    	temperature=0;
	mov [X+0],0
	mov [X+1],0
	mov [X+2],0
	mov [X+3],0
	.dbline 239
;    	count =0;
	mov [X+37],0
	mov [X+36],0
	.dbline 240
;    	LCD_1_Position(1,10);
	push X
	mov X,10
	mov A,1
	xcall _LCD_1_Position
	pop X
	.dbline 241
;   		LCD_1_PrString(lcd_Setting);
	mov [__r1],X
	add [__r1],14
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _LCD_1_PrString
	pop X
	.dbline 242
;     goto AboveTop;
	xjmp L2
L75:
	.dbline 244
;   Stop:
;    	LCD_1_Control(LCD_1_DISP_CLEAR_HOME);
	push X
	mov A,1
	xcall _LCD_1_Control
	.dbline 246
;    	
;    	LCD_1_Position(0,0);            			 
	mov A,0
	mov X,A
	xcall _LCD_1_Position
	.dbline 247
;   		LCD_1_PrCString("STOPPED at");
	mov A,>L87
	push A
	mov A,<L87
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 248
;   		LCD_1_PrString(lcd_Reading); 
	mov [__r1],X
	add [__r1],22
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _LCD_1_PrString
	.dbline 250
;    		
;    	DAC9_1_WriteBlind(0);
	mov A,0
	mov X,A
	xcall _DAC9_1_WriteBlind
	pop X
	.dbline 251
;    	stop=1;
	mov [X+7],1
	mov [X+6],0
	.dbline 252
;    	if (base==0)
	cmp [X+8],0
	jnz L88
	cmp [X+9],0
	jnz L88
X58:
	.dbline 253
;   					{
	.dbline 254
;   						MAXC=TEMPF;
	mov [_MAXC+1],[_TEMPF+1]
	mov [_MAXC],[_TEMPF]
	.dbline 255
;   						LCD_1_Position(0,15);
	push X
	mov X,15
	mov A,0
	xcall _LCD_1_Position
	.dbline 256
;   						LCD_1_PrCString("F");
	mov A,>L6
	push A
	mov A,<L6
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 258
;   						 
;   					}else 
	xjmp L12
L88:
	.dbline 259
;   						{
	.dbline 260
;   							MAXC=TEMPC;
	mov [_MAXC+1],[_TEMPC+1]
	mov [_MAXC],[_TEMPC]
	.dbline 261
;   							LCD_1_Position(0,15);
	push X
	mov X,15
	mov A,0
	xcall _LCD_1_Position
	.dbline 262
;   							LCD_1_PrCString("C");
	mov A,>L7
	push A
	mov A,<L7
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 264
;    							
;   						}
	.dbline 265
;     goto Top;
	xjmp L12
L73:
	.dbline 268
;   Start:
;    		
;   		LCD_1_Control(LCD_1_DISP_CLEAR_HOME);
	push X
	mov A,1
	xcall _LCD_1_Control
	.dbline 270
;    	
;   				LCD_1_Position(0,0);            			 
	mov A,0
	mov X,A
	xcall _LCD_1_Position
	.dbline 271
;   				LCD_1_PrCString("HEATING to ");
	mov A,>L90
	push A
	mov A,<L90
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 272
;   				LCD_1_PrString(lcd_Setting);
	mov [__r1],X
	add [__r1],14
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _LCD_1_PrString
	pop X
	.dbline 274
;    		
;    	if (InputADC<=temperature)
	mov A,[X+5]
	mov [__r3],A
	mov A,[X+4]
	mov [__r2],A
	tst [__r2],-128
	jz X59
	mov [__r1],-1
	mov [__r0],-1
	jmp X60
X59:
	mov [__r1],0
	mov [__r0],0
X60:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,1
	jz L91
	.dbline 275
;    	{	
	.dbline 277
;     	
;    		DAC9_1_WriteBlind(510);
	push X
	mov X,1
	mov A,-2
	xcall _DAC9_1_WriteBlind
	pop X
	.dbline 278
;    	}else 
	xjmp L92
L91:
	.dbline 279
;    		{
	.dbline 280
;    			DAC9_1_WriteBlind(0);
	push X
	mov A,0
	mov X,A
	xcall _DAC9_1_WriteBlind
	pop X
	.dbline 282
;    		
;   			}
L92:
	.dbline 284
;     	
;    	stop=0;
	mov [X+7],0
	mov [X+6],0
	.dbline 285
;    	if (base==0)
	cmp [X+8],0
	jnz L93
	cmp [X+9],0
	jnz L93
X62:
	.dbline 286
;   					{
	.dbline 287
;   						MAXC=TEMPF;
	mov [_MAXC+1],[_TEMPF+1]
	mov [_MAXC],[_TEMPF]
	.dbline 288
;   						LCD_1_Position(0,15);
	push X
	mov X,15
	mov A,0
	xcall _LCD_1_Position
	.dbline 289
;   						LCD_1_PrCString("F");
	mov A,>L6
	push A
	mov A,<L6
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 291
;    						 
;   					}else 
	xjmp L12
L93:
	.dbline 292
;   						{
	.dbline 293
;   							MAXC=TEMPC;
	mov [_MAXC+1],[_TEMPC+1]
	mov [_MAXC],[_TEMPC]
	.dbline 294
;   							LCD_1_Position(0,15);
	push X
	mov X,15
	mov A,0
	xcall _LCD_1_Position
	.dbline 295
;   							LCD_1_PrCString("C");
	mov A,>L7
	push A
	mov A,<L7
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline 297
;   							
;   						}
	.dbline 298
;     goto Top;
	xjmp L12
L66:
	.dbline 300
;    LOWlimit:
;    	temperature=0;
	mov [X+0],0
	mov [X+1],0
	mov [X+2],0
	mov [X+3],0
	.dbline 301
;    	goto Top;
	xjmp L12
L57:
	.dbline 303
;    HIGHlimit:
;    	temperature=MAXC;
	mov A,[_MAXC+1]
	mov [X+3],A
	mov A,[_MAXC]
	mov [X+2],A
	tst [X+2],-128
	jz X63
	mov [X+1],-1
	mov [X+0],-1
	jmp X64
X63:
	mov [X+1],0
	mov [X+0],0
X64:
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __long2fp
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 304
;    	goto Top;
	xjmp L12
L79:
	.dbline 307
;    Base:
;    
;    	if (base==1)//Degrees F to Degrees C
	cmp [X+8],0
	jnz L95
	cmp [X+9],1
	jnz L95
X65:
	.dbline 308
;    	{
	.dbline 309
;    		if (temperature!=0)
	mov A,0
	push A
	push A
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,0
	jz L99
	.dbline 310
;    		{
	.dbline 311
;    			temperature2=temperature;
	mov A,[X+0]
	mov [X+30],A
	mov A,[X+1]
	mov [X+31],A
	mov A,[X+2]
	mov [X+32],A
	mov A,[X+3]
	mov [X+33],A
	.dbline 312
;    			temperature=(5.0/9.0*(temperature2-32)); // convert F to C
	mov A,66
	push A
	mov A,0
	push A
	push A
	push A
	mov A,[X+30]
	push A
	mov A,[X+31]
	push A
	mov A,[X+32]
	push A
	mov A,[X+33]
	push A
	xcall __fpsub
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	add SP,-4
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,63
	push A
	mov A,14
	push A
	mov A,56
	push A
	mov A,-28
	push A
	xcall __fpmul
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 313
;    		}
	.dbline 314
;    		goto BaseBottom;
	xjmp L99
L95:
	.dbline 317
;    	}else
;    	
;    		if (temperature!=0)
	mov A,0
	push A
	push A
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,0
	jz L100
	.dbline 318
;    		{
	.dbline 319
;    			temperature2=temperature;
	mov A,[X+0]
	mov [X+30],A
	mov A,[X+1]
	mov [X+31],A
	mov A,[X+2]
	mov [X+32],A
	mov A,[X+3]
	mov [X+33],A
	.dbline 320
;    			temperature=(9.0/5.0*temperature2)+32; // convert C to F
	mov A,[X+30]
	push A
	mov A,[X+31]
	push A
	mov A,[X+32]
	push A
	mov A,[X+33]
	push A
	mov A,63
	push A
	mov A,-26
	push A
	mov A,102
	push A
	push A
	xcall __fpmul
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,66
	push A
	mov A,0
	push A
	push A
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpadd
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 321
;    		}
L100:
L99:
	.dbline 325
; 	
;     	
;    	BaseBottom:
;    		if (stop==0)
	cmp [X+6],0
	jz X69
	ljmp L2
X69:
	cmp [X+7],0
	jz X70
	ljmp L2
X70:
X68:
	.dbline 326
;    		 {
	.dbline 327
;    		 	goto Top;
	xjmp L12
X10:
	.dbline 328
;    		 }else goto AboveTop;
	.dbline 66
	.dbline 66
	.dbline -2
L1:
	add SP,-50
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l KeyBuffer 46 I
	.dbsym l InputADC2 44 I
	.dbsym l CycleBuffer 42 I
	.dbsym l z 40 I
	.dbsym l w 38 I
	.dbsym l count 36 I
	.dbsym l buffer 34 I
	.dbsym l temperature2 30 D
	.dbsym l lcd_Reading 22 A[8:8]c
	.dbsym l lcd_Setting 14 A[8:8]c
	.dbsym l x 12 I
	.dbsym l KeyRead 10 I
	.dbsym l base 8 I
	.dbsym l stop 6 I
	.dbsym l InputADC 4 I
	.dbsym l temperature 0 D
	.dbend
	.area lit(rom, con, rel)
L90:
	.byte 'H,'E,'A,'T,'I,'N,'G,32,'t,'o,32,0
L87:
	.byte 'S,'T,'O,'P,'P,'E,'D,32,'a,'t,0
L39:
	.byte 'S,'E,'T,45,62,0
L7:
	.byte 'C,0
L6:
	.byte 'F,0
L3:
	.byte 'M,'A,'X,32,'L,'i,'m,'i,'t,0
